#line 1 "D:/Proekti/Termostat LCD/TermostatLCD.c"
#line 1 "d:/proekti/termostat lcd/ar2r.h"

void Ar2rSplash(void);
unsigned short BCDMask(unsigned short num);
unsigned short Days(unsigned short mon, unsigned int ye);
unsigned short IsLeapYear(unsigned int yea);
signed short ConTemp(unsigned temp);
unsigned short dstm(unsigned int mye);
unsigned short dsto(unsigned int yeo);
void Comm_Write(unsigned char *s);
unsigned char *WTS(int s2);
#line 1 "c:/program files/mikroelektronika/mikroc/include/built_in.h"
#line 18 "D:/Proekti/Termostat LCD/TermostatLCD.c"
unsigned short but1, but2, but3, tol, ttol, pwr, set, tick, bep;
short tem, stem, tstem;
unsigned temp;
unsigned char ch;
unsigned short ch1, ch2;



void ReadTemperature()
{
 Ow_Reset(&PORTA,2);
 Ow_Write(&PORTA,2,0xCC);
 Ow_Write(&PORTA,2,0x44);
 Delay_us(120);

 Ow_Reset(&PORTA,2);
 Ow_Write(&PORTA,2,0xCC);
 Ow_Write(&PORTA,2,0xBE);
 Delay_ms(300);

  ((char *)&temp)[0]  = Ow_Read(&PORTA,2);
  ((char *)&temp)[1]  = Ow_Read(&PORTA,2);
}


void ChE(void)
{
 if(ch1==1)
 {
 EEprom_Write(0, stem);
 ch1=0;
 }
 if(ch2==1)
 {
 EEprom_Write(1, tol);
 ch2=0;
 }
}


void LC1(void)
{
 ch=(tem/10) %10;
 LCD_Chr(1,1, 32);
 if (ch==0)
 {
 LCD_Chr_Cp(32);
 }
 else
 {
 LCD_Chr_Cp(48+ch);
 }
 ch=tem %10;
 LCD_Chr_Cp(48+ch);
 Lcd_Chr_Cp(223);
 Lcd_Chr_Cp('C');
 Lcd_Chr_Cp(' ');
 Lcd_Chr_Cp(' ');
 Lcd_Chr_Cp(' ');

 ch=(stem/10) %10;
 if (ch==0)
 {
 LCD_Chr(2,1, 32);
 }
 else
 {
 LCD_Chr(2,1,48+ch);
 }
 ch=stem %10;
 LCD_Chr_Cp(48+ch);
 Lcd_Chr_Cp(223);
 Lcd_Chr_Cp('C');
 Lcd_Chr_Cp(' ');
 switch(pwr)
 {
 case 0:
 LCD_Chr_Cp('O');
 Lcd_Chr_Cp('f');
 Lcd_Chr_Cp('f');
 break;
 case 1:
 LCD_Chr_Cp('O');
 Lcd_Chr_Cp('n');
 Lcd_Chr_Cp(' ');
 break;
 }
}


void LC2(void)
{
 LCD_Out(1,1, "  Temp.=");
 ch=(stem/10) %10;
 if (ch==0)
 {
 LCD_Chr(2,1, 32);
 }
 else
 {
 LCD_Chr(2,1, 48+ch);
 }
 ch=stem %10;
 LCD_Chr_Cp(48+ch);
 Lcd_Chr_Cp(223);
 Lcd_Chr_Cp('C');
 Lcd_Chr_Cp(' ');
 Lcd_Chr_Cp(' ');
 Lcd_Chr_Cp(' ');
 Lcd_Chr_Cp(' ');
}


void LC3(void)
{
 LCD_Out(1,1, "  Hyst.=");
 ch=(tol/10) %10;
 if (ch==0)
 {
 LCD_Chr(2,1, 32);
 }
 else
 {
 LCD_Chr(2,1, 48+ch);
 }
 ch=tol %10;
 LCD_Chr_Cp(48+ch);
 Lcd_Chr_Cp(223);
 Lcd_Chr_Cp('C');
 Lcd_Chr_Cp(' ');
 Lcd_Chr_Cp(' ');
 Lcd_Chr_Cp(' ');
 Lcd_Chr_Cp(' ');
}


void Beep(int y, int c)
{
 int z;
 for(z=0;z<=c;z++)
 {
 PORTB.F6=1;
 Vdelay_ms(y);
 PORTB.F6=0;
 Vdelay_ms(y);
 }
}


void main()
{
 CMCON = 0b00000111;
 TRISA = 0b11111100;
 PORTA.F1 = 0;
 ch2=ch1=0; but1=but2=but3=0; pwr=0; bep=tick=set=0;


 Lcd_Config(&PORTB, 0, 1, 6, 5, 4, 3, 2);
 TRISB.F6 = 0;
 TRISB.F7 = 1;

 stem=Eeprom_Read(0);
 if (stem<=0 || stem>=91)
 {
 stem=65;
 ch1=1;
 }
 tol=Eeprom_Read(1);
 if (tol>=86)
 {
 tol=5;
 ch2=1;
 }

 Lcd_Cmd(Lcd_CURSOR_OFF);
 Ar2rSplash();
 LCD_Cmd(LCD_CLEAR);

 while (1)
 {
 ChE();
 ReadTemperature();
 tem=ConTemp(temp);
 if(tem>=1 && tem<=stem-tol)
 {
 PORTA.F1=1;
 pwr=1;
 bep=1;
 }
 if(tem>stem || tem<=0)
 {
 PORTA.F1=0;
 pwr=0;
 if(bep==1)
 {
 Beep(1,1000);
 bep=0;
 }
 }
 if(tem<=0) Beep(2,200);

 switch(set)
 {
 case 0: LC1(); break;
 case 1: LC2(); break;
 case 2: LC3(); break;
 }

 if(set>=1) tick++;
 if(tick>=40)
 {
 tick=set=0;
 tol=ttol;
 stem=tstem;
 }

 if (PORTA.F5==0) but3 = 1;
 if (but3==1 && PORTA.F5==1)
 {
 tick=but3 = 0;
 switch(set)
 {
 case 1:
 stem++;
 if(stem>=91) stem=1;
 LC2();
 break;
 case 2:
 tol++;
 if(tol>=86) tol=1;
 LC3();
 break;
 }
 }

 if (PORTA.F4==0) but2 = 1;
 if (but2==1 && PORTA.F4==1)
 {
 tick=but2 = 0;
 switch(set)
 {
 case 1:
 stem--;
 if(stem<=0) stem=90;
 LC2();
 break;
 case 2:
 tol--;
 if(tol<=0) tol=85;
 LC3();
 break;
 }
 }

 if (PORTA.F3==0) but1 = 1;
 if (but1==1 && PORTA.F3==1)
 {
 tick=but1 = 0;
 set++;
 if(set==1)
 {
 tstem=stem;
 ttol=tol;
 }
 if(set>=3)
 {
 tick=set=0;
 if(tstem!=stem) ch1=1;
 if(ttol!=tol) ch2=1;
 }
 }
 }
}
